﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	
	
	public class Main extends MovieClip
	{
		
		private var _width:Number;
		private var _height:Number;
		
		private var onScreenBitmapData:BitmapData;
		private var onScreenBitmap:Bitmap;
		private var offScreenCanvas:Sprite;
		
		private var MINLINEWIDTH:Number = 10;
		private var MAXLINEWIDTH:Number = -25;
		private var MINLINEHEIGHT:Number = -5;
		private var MAXLINEHEIGHT:Number = 20;
		
		private var BUNCHWIDTH:Number = 70;
		private var NUMLINES:Number = 15;
		
		private var VERTICAL:Number = 0;
		private var HORIZONTAL:Number = 1;
		
		private var _currentPoints:Array;
		private var prevStartPoint:Number;
		private var _currentDirection:Number;
		
		public function Main():void
		{
			_width = 800;
			_height = 600;
			
			var backgroundNoise:BitmapData = new BitmapData(_width, _height, false, 0xFFFFFF);
			
			backgroundNoise.perlinNoise(200, 100, 2, 1000, true, true, 8, true);
			backgroundNoise.colorTransform(new Rectangle(0, 0, _width, _height), new ColorTransform(0, 0, .4));
			
			var backgroundBitmap:Bitmap = new Bitmap(backgroundNoise);
			
			this.addChild(backgroundBitmap);
			
			
			offScreenCanvas = new Sprite();
			onScreenBitmapData = new BitmapData(_width, _height, true, 0x00000000);
			onScreenBitmap = new Bitmap(onScreenBitmapData);
			
			_currentPoints = new Array();
			
			_currentDirection = VERTICAL;
			
			this.addChild(onScreenBitmap);
			
			generateStart();
			this.addEventListener(Event.ENTER_FRAME, move);
		}
		
		private function generateStart():void
		{
			var startX:Number;
			
			if(isNaN(prevStartPoint))
			{
				startX =  Math.random() * _width;
			}else
			{
				
				startX = ((Math.random()*BUNCHWIDTH)+BUNCHWIDTH*2 + prevStartPoint)%_width;
				
			}
			
			for (var i:Number = 0; i < NUMLINES; i++)
			{
				_currentPoints[i] = new Point(Math.random() *BUNCHWIDTH+ startX, 0);
			}
			
			prevStartPoint = startX;
			trace("start");
		}
		
		
		private function move(e:Event):void
		{
			
			offScreenCanvas.graphics.clear();
			
			var allEnded:Boolean = true;
			
			for (var i:Number = 0; i < NUMLINES; i++)
			{
				offScreenCanvas.graphics.moveTo(_currentPoints[i].x,_currentPoints[i].y);
				//offScreenCanvas.graphics.moveTo(0,0);
				if (_currentPoints[i].x > 0)
				{
					var newX:Number;
					var newY:Number;
					
					if(_currentDirection==VERTICAL){
						newX = _currentPoints[i].x;
						newY = _currentPoints[i].y + (Math.random() * (MAXLINEHEIGHT - MINLINEHEIGHT)) + MINLINEHEIGHT;
						_currentDirection = HORIZONTAL;
					}else
					{
						newX = _currentPoints[i].x + (Math.random()*(MAXLINEWIDTH-MINLINEWIDTH))+MINLINEWIDTH;
						newY= _currentPoints[i].y;
						_currentDirection = VERTICAL;
					}
					
					var xRatio:Number = Math.abs(_width/2-_currentPoints[i].x);
					var yRatio:Number = Math.abs(_height / 2 - _currentPoints[i].y);
					var yValue:Number = easeOutQuad(yRatio,0, 1, _height/2);
					var xValue:Number = easeOutQuad(xRatio,0, 1, _width/2);
					
					
					offScreenCanvas.graphics.lineStyle(2, 0xFFFFFF, 1-(yValue+xValue)/2);
					
					_currentPoints[i].x = newX;
					_currentPoints[i].y = newY;
					offScreenCanvas.graphics.lineTo(newX, newY);
					allEnded = false;
				}
			}
			
			onScreenBitmapData.applyFilter(onScreenBitmapData, new Rectangle(0, 0, _width, _height),new Point(0,0),new BlurFilter(1.1, 1.1, 1));
			onScreenBitmapData.draw(offScreenCanvas);
			
			if (allEnded)
			{
				generateStart();
			}
			
		}
		
		public function easeOutQuad(t:Number, b:Number, c:Number, d:Number):Number{
			t /= d;
			return c*t*t + b;
		}
		
	}
}